Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem.F90	(revision 3211)
@@ -32,4 +32,9 @@
 
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_tem      ! structure of input SST (file informations, fields read)
+
+   !! * Control permutation of array indices
+#  include "dtatem_ftrans.h90"
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -171,5 +176,17 @@
 #endif
          
+#if defined key_z_first
+      !! DCSE_NEMO: Beware! These arrays will not be conformable after permuting indices of t_dta
+      DO jk = 1, jpk
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               t_dta(ji,jj,jk) = sf_tem(1)%fnow(ji,jj,jk) 
+            END DO
+         END DO
+      END DO
+#else
       t_dta(:,:,:) = sf_tem(1)%fnow(:,:,:) 
+#endif
+
          
       IF( ln_sco ) THEN
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem_ftrans.h90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem_ftrans.h90	(revision 3211)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DTA/dtatem_ftrans.h90	(revision 3211)
@@ -0,0 +1,21 @@
+   !!----------------------------------------------------------------------
+   !!                   ***  dtatem_ftrans  ***
+   !!----------------------------------------------------------------------
+   !! ** purpose : Directives to control permutation of array indices
+   !!   for multi-dimensional arrays with a z-dimension declared in module
+   !!   dtatem.  It should be included wherever the module is used,
+   !!   and updated whenever a new array is added to the module.
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2011)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+#if defined key_z_first
+!FTRANS assert :z :I
+#else
+!FTRANS assert :I :z
+#endif
+!FTRANS t_dta :I :I :z
+
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 3211)
@@ -37,4 +37,9 @@
 
    PUBLIC   div_cur    ! routine called by step.F90 and istate.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "obc_oce_ftrans.h90"
 
    !! * Substitutions
@@ -285,4 +290,52 @@
       ENDIF
 
+#if defined key_z_first
+      !                                             ! --------
+      ! Horizontal divergence                       !   div 
+      !                                             ! --------
+      hdivb(:,:,1:jpkm1) = hdivn(:,:,1:jpkm1)    ! time swap of div arrays
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+               hdivn(ji,jj,jk) =   &
+                  (  e2u(ji,jj)*fse3u(ji,jj,jk) * un(ji,jj,jk) - e2u(ji-1,jj)*fse3u(ji-1,jj,jk) * un(ji-1,jj,jk)       &
+                   + e1v(ji,jj)*fse3v(ji,jj,jk) * vn(ji,jj,jk) - e1v(ji,jj-1)*fse3v(ji,jj-1,jk) * vn(ji,jj-1,jk)  )    &
+                  / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+            END DO  
+         END DO  
+      END DO
+
+#if defined key_obc
+      IF( Agrif_Root() ) THEN
+         ! open boundaries (div must be zero behind the open boundary)
+         !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
+         IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,1:jpkm1) = 0.e0      ! east
+         IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,1:jpkm1) = 0.e0      ! west
+         IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,1:jpkm1) = 0.e0      ! north
+         IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,1:jpkm1) = 0.e0      ! south
+      ENDIF
+#endif         
+      IF( .NOT. AGRIF_Root() ) THEN
+         IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,1:jpkm1) = 0.e0      ! east
+         IF ((nbondi == -1).OR.(nbondi == 2)) hdivn(2      , :     ,1:jpkm1) = 0.e0      ! west
+         IF ((nbondj ==  1).OR.(nbondj == 2)) hdivn(:      ,nlcj-1 ,1:jpkm1) = 0.e0      ! north
+         IF ((nbondj == -1).OR.(nbondj == 2)) hdivn(:      ,2      ,1:jpkm1) = 0.e0      ! south
+      ENDIF
+
+         !                                             ! --------
+         ! relative vorticity                          !   rot 
+         !                                             ! --------
+      rotb (:,:,1:jpkm1) = rotn (:,:,1:jpkm1)    ! time swap of rot arrays
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 1, jpkm1
+               rotn(ji,jj,jk) = (  e2v(ji+1,jj  ) * vn(ji+1,jj  ,jk) - e2v(ji,jj) * vn(ji,jj,jk)    &
+                  &              - e1u(ji  ,jj+1) * un(ji  ,jj+1,jk) + e1u(ji,jj) * un(ji,jj,jk)  ) &
+                  &           * fmask(ji,jj,jk) / ( e1f(ji,jj) * e2f(ji,jj) )
+            END DO
+         END DO
+      END DO
+#else
+
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -334,4 +387,5 @@
       END DO                                           !   End of slab
       !                                                ! ===============
+#endif
 
       IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv.F90	(revision 3211)
@@ -31,4 +31,7 @@
    
    INTEGER ::   nadv   ! choice of the formulation and scheme for the advection
+
+   !! * Control permutation of array indices
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_cen2.F90	(revision 3211)
@@ -26,4 +26,8 @@
    PUBLIC   dyn_adv_cen2   ! routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -52,4 +56,14 @@
       USE wrk_nemo, ONLY:   zfu_f => wrk_3d_2 , zfv_f => wrk_3d_5 , zfv_vw =>wrk_3d_7
       USE wrk_nemo, ONLY:   zfw   => wrk_3d_3 
+      !! DCSE_NEMO: module variables renamed, need additional directives
+!FTRANS zfu :I :I :z
+!FTRANS zfv :I :I :z
+!FTRANS zfu_t :I :I :z
+!FTRANS zfv_t :I :I :z
+!FTRANS zfu_uw :I :I :z
+!FTRANS zfu_f :I :I :z
+!FTRANS zfv_f :I :I :z
+!FTRANS zfv_vw :I :I :z
+!FTRANS zfw :I :I :z
       !
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynadv_ubs.F90	(revision 3211)
@@ -30,4 +30,8 @@
 
    PUBLIC   dyn_adv_ubs   ! routine called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
 
    !! * Substitutions
@@ -75,4 +79,18 @@
       USE wrk_nemo, ONLY:   zlu_uu => wrk_4d_1 , zlv_vv=>wrk_4d_3   ! 4D workspace
       USE wrk_nemo, ONLY:   zlu_uv => wrk_4d_2 , zlv_vu=>wrk_4d_4
+      !! DCSE_NEMO: module variables renamed, need additional directives
+!FTRANS zfu :I :I :z
+!FTRANS zfv :I :I :z
+!FTRANS zfu_t :I :I :z
+!FTRANS zfv_t :I :I :z
+!FTRANS zfu_uw :I :I :z
+!FTRANS zfu_f :I :I :z
+!FTRANS zfv_f :I :I :z
+!FTRANS zfv_vw :I :I :z
+!FTRANS zfw :I :I :z
+!FTRANS zlu_uu :I :I :z :I
+!FTRANS zlv_vv :I :I :z :I
+!FTRANS zlu_uv :I :I :z :I
+!FTRANS zlv_vu :I :I :z :I
       !
       INTEGER, INTENT(in) ::   kt     ! ocean time-step index
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynbfr.F90	(revision 3211)
@@ -23,4 +23,9 @@
    PUBLIC   dyn_bfr    !  routine called by step.F90
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -43,4 +48,7 @@
       !!---------------------------------------------------------------------
       USE oce, ONLY:   ztrduv => tsa   ! tsa used as 4D workspace
+      !! DCSE_NEMO: module variable renamed, need additional directives
+!FTRANS ztrduv :I :I :z :I
+
       !!
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 3211)
@@ -57,4 +57,8 @@
    INTEGER  ::   nhpg  =  0   ! = 0 to 6, type of pressure gradient scheme used ! (deduced from ln_hpg_... flags)
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -79,4 +83,8 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztrdu => wrk_3d_1 , ztrdv => wrk_3d_2   ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
+
       !!
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
@@ -194,4 +202,8 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   zhpi => ta , zhpj => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
+
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -223,7 +235,13 @@
       !
       ! interior value (2=<jk=<jpkm1)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zcoef1 = zcoef0 * fse3w(ji,jj,jk)
                ! hydrostatic pressure gradient
@@ -254,4 +272,7 @@
       !!---------------------------------------------------------------------- 
       USE oce, ONLY:   zhpi => ta , zhpj => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -285,7 +306,13 @@
 
       ! interior value (2=<jk=<jpkm1)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zcoef1 = zcoef0 * fse3w(ji,jj,jk)
                ! hydrostatic pressure gradient
@@ -355,4 +382,7 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   zhpi => ta , zhpj => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -395,7 +425,13 @@
             
       ! interior value (2=<jk=<jpkm1)
+#if defined key_z_first
+      DO jj = 2, jpjm1     
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1                                  
+#else
       DO jk = 2, jpkm1                                  
          DO jj = 2, jpjm1     
             DO ji = fs_2, fs_jpim1   ! vector opt.      
+#endif
                ! hydrostatic pressure gradient along s-surfaces
                zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) + zcoef0 / e1u(ji,jj)   & 
@@ -440,4 +476,7 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   zhpi => ta , zhpj => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -476,7 +515,13 @@
       !
       ! interior value (2=<jk=<jpkm1)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ! hydrostatic pressure gradient along s-surfaces
                zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) &
@@ -516,4 +561,7 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY:   zhpi => ta , zhpj => sa   ! (ta,sa) used as 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -555,7 +603,13 @@
 
       ! Interior value (2=<jk=<jpkm1) (weighted with zalph & zbeta)
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1) + zcoef0 / e1u(ji,jj)                            &
                   &           * (   (            fsde3w(ji+1,jj,jk  ) + fsde3w(ji,jj,jk  )        &
@@ -603,4 +657,22 @@
       USE wrk_nemo, ONLY:   drhow => wrk_3d_13 , dzw  => wrk_3d_14
       USE wrk_nemo, ONLY:   rho_k => wrk_3d_15
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
+!FTRANS drhox :I :I :z
+!FTRANS dzx :I :I :z
+!FTRANS drhou :I :I :z
+!FTRANS dzu :I :I :z
+!FTRANS rho_i :I :I :z
+!FTRANS drhoy :I :I :z
+!FTRANS dzy :I :I :z
+!FTRANS drhov :I :I :z
+!FTRANS dzv :I :I :z
+!FTRANS rho_j :I :I :z
+!FTRANS drhoz :I :I :z
+!FTRANS dzz :I :I :z
+!FTRANS drhow :I :I :z
+!FTRANS dzw :I :I :z
+!FTRANS rho_k :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -633,7 +705,13 @@
 !!bug gm   Not a true bug, but... dzz=e3w  for dzx, dzy verify what it is really
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                drhoz(ji,jj,jk) = rhd   (ji  ,jj  ,jk) - rhd   (ji,jj,jk-1)
                dzz  (ji,jj,jk) = fsde3w(ji  ,jj  ,jk) - fsde3w(ji,jj,jk-1)
@@ -654,7 +732,13 @@
 !!bug  gm  idem for drhox, drhoy et ji=jpi and jj=jpj
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                cffw = 2._wp * drhoz(ji  ,jj  ,jk) * drhoz(ji,jj,jk-1)
 
@@ -739,7 +823,13 @@
 !!bug gm    : optimisation: 1/10 and 1/12 the division should be done before the loop
 
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
 
                rho_k(ji,jj,jk) = zcoef0 * ( rhd   (ji,jj,jk) + rhd   (ji,jj,jk-1) )                                   &
@@ -794,7 +884,13 @@
       !  interior value   (2=<jk=<jpkm1)
       ! ----------------
+#if defined key_z_first
+      DO jj = 2, jpjm1 
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1 
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ! hydrostatic pressure gradient along s-surfaces
                zhpi(ji,jj,jk) = zhpi(ji,jj,jk-1)                                &
@@ -832,4 +928,15 @@
       USE wrk_nemo, ONLY:   zhpjorg => wrk_3d_5 , zhpjrot => wrk_3d_6
       USE wrk_nemo, ONLY:   zhpjtra => wrk_3d_7 , zhpjne  => wrk_3d_8
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zhpi :I :I :z
+!FTRANS zhpj :I :I :z
+!FTRANS zhpiorg :I :I :z
+!FTRANS zhpirot :I :I :z
+!FTRANS zhpitra :I :I :z
+!FTRANS zhpine :I :I :z
+!FTRANS zhpjorg :I :I :z
+!FTRANS zhpjrot :I :I :z
+!FTRANS zhpjtra :I :I :z
+!FTRANS zhpjne :I :I :z
       !!
       INTEGER, INTENT(in) ::   kt    ! ocean time-step index
@@ -891,6 +998,11 @@
       DO jj = 1, jpjm1
          DO ji = 1, fs_jpim1   ! vector opt.
+#if defined key_z_first
+            zmskd1 = tmask_1(ji+1,jj+1) * tmask_1(ji  ,jj)      ! mask in the 1st diagnonal
+            zmskd2 = tmask_1(ji  ,jj+1) * tmask_1(ji+1,jj)      ! mask in the 2nd diagnonal
+#else
             zmskd1 = tmask(ji+1,jj+1,1) * tmask(ji  ,jj,1)      ! mask in the 1st diagnonal
             zmskd2 = tmask(ji  ,jj+1,1) * tmask(ji+1,jj,1)      ! mask in the 2nd diagnonal
+#endif
             ! hydrostatic pressure gradient along s-surfaces
             zhpitra(ji,jj,1) = zdistr(ji,jj) * zmskd1 * (  fse3t(ji+1,jj+1,1) * rhd(ji+1,jj+1,1)   &
@@ -927,7 +1039,13 @@
       ! -----------------
       ! compute and add to the general trend the pressure gradients along the axes
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ! hydrostatic pressure gradient along s-surfaces
                zhpiorg(ji,jj,jk) = zhpiorg(ji,jj,jk-1)                                                 &
@@ -954,7 +1072,13 @@
 
       ! compute the pressure gradients in the diagonal directions
+#if defined key_z_first
+      DO jj = 1, jpjm1
+         DO ji = 1, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
+#endif
                zmskd1  = tmask(ji+1,jj+1,jk  ) * tmask(ji  ,jj,jk  )      ! level jk   mask in the 1st diagnonal
                zmskd1m = tmask(ji+1,jj+1,jk-1) * tmask(ji  ,jj,jk-1)      ! level jk-1    "               "     
@@ -987,7 +1111,13 @@
 
       ! interpolate and add to the general trend
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 2, jpkm1
+#else
       DO jk = 2, jpkm1
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ! averaging
                zhpirot(ji,jj,jk) = 0.5 * ( zhpine(ji,jj,jk) + zhpine(ji  ,jj-1,jk) )
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 3211)
@@ -24,4 +24,8 @@
 
    PUBLIC   dyn_keg    ! routine called by step module
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
    
    !! * Substitutions
@@ -55,4 +59,7 @@
       USE oce     , ONLY:   ztrdu => ta       , ztrdv => sa   ! (ta,sa) used as 3D workspace   
       USE wrk_nemo, ONLY:   zhke  => wrk_3d_1                 ! 3D workspace
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu ztrdv zhke :I :I :z
+
       !!
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -77,4 +84,24 @@
       ENDIF
       
+#if defined key_z_first
+      DO jj = 2, jpj            ! Horizontal kinetic energy at T-point
+         DO ji = 2, jpi
+            DO jk = 1, jpkm1
+               zhke(ji,jj,jk) = 0.25 * (   un(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)   &
+                  &                      + un(ji  ,jj  ,jk) * un(ji  ,jj  ,jk)   &
+                                         + vn(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)   &
+                  &                      + vn(ji  ,jj  ,jk) * vn(ji  ,jj  ,jk)   )
+            END DO  
+         END DO  
+      END DO
+      DO jj = 2, jpjm1          ! add the gradient of kinetic energy to the general momentum trends
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+               ua(ji,jj,jk) = ua(ji,jj,jk) - ( zhke(ji+1,jj  ,jk) - zhke(ji,jj,jk) ) / e1u(ji,jj)
+               va(ji,jj,jk) = va(ji,jj,jk) - ( zhke(ji  ,jj+1,jk) - zhke(ji,jj,jk) ) / e2v(ji,jj)
+            END DO 
+         END DO
+      END DO
+#else
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -126,4 +153,5 @@
       END DO                                           !   End of slab
       !                                                ! ===============
+#endif
 
       IF( l_trddyn ) THEN      ! save the Kinetic Energy trends for diagnostic
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 3211)
@@ -35,4 +35,10 @@
    INTEGER ::   nldf = -2   ! type of lateral diffusion used defined from ln_dynldf_... namlist logicals)
 
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -53,4 +59,8 @@
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztrdu => wrk_3d_1 , ztrdv => wrk_3d_2
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS ztrdu :I :I :z
+!FTRANS ztrdv :I :I :z
+
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 3211)
@@ -28,4 +28,9 @@
 
    PUBLIC   dyn_ldf_bilap   ! called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
 
    !! * Substitutions
@@ -75,7 +80,12 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   zcu => wrk_2d_1 , zcv => wrk_2d_2   ! 3D workspace
+      USE wrk_nemo, ONLY:   zcu => wrk_2d_1 , zcv => wrk_2d_2   ! 2D workspace
       USE wrk_nemo, ONLY:   zuf => wrk_3d_3 , zut => wrk_3d_4   ! 3D workspace
       USE wrk_nemo, ONLY:   zlu => wrk_3d_5 , zlv => wrk_3d_6
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zuf :I :I :z
+!FTRANS zut :I :I :z
+!FTRANS zlu :I :I :z
+!FTRANS zlv :I :I :z
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 3211)
@@ -35,4 +35,11 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  zfuw, zfvw , zdiu, zdiv   ! 2D workspace (ldfguv)
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::  zdju, zdj1u, zdjv, zdj1v  ! 2D workspace (ldfguv)
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
 
    !! * Substitutions
@@ -87,4 +94,9 @@
       USE wrk_nemo, ONLY:   zwk1 => wrk_3d_3 , zwk2 => wrk_3d_4   ! 3D workspace
       USE oce     , ONLY:   zwk3 => ta       , zwk4 => sa         ! ta, sa used as 3D workspace   
+      !! DCSE_NEMO: need additional directives for renamed module variables
+!FTRANS zwk1 :I :I :z
+!FTRANS zwk2 :I :I :z
+!FTRANS zwk3 :I :I :z
+!FTRANS zwk4 :I :I :z
       !
       INTEGER, INTENT( in ) ::   kt           ! ocean time-step index
@@ -120,7 +132,13 @@
       ! Update the momentum trends
       ! --------------------------
+#if defined key_z_first
+      DO jj = 2, jpjm1               ! add the diffusive trend to the general momentum trends
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       DO jj = 2, jpjm1               ! add the diffusive trend to the general momentum trends
          DO jk = 1, jpkm1
             DO ji = 2, jpim1
+#endif
                ua(ji,jj,jk) = ua(ji,jj,jk) + zwk3(ji,jj,jk)
                va(ji,jj,jk) = va(ji,jj,jk) + zwk4(ji,jj,jk)
@@ -180,9 +198,16 @@
       USE wrk_nemo, ONLY:   zdkv => wrk_2d_7 , zdk1v => wrk_2d_8
       !!
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   pu , pv    ! 1st call: before horizontal velocity 
+!FTRANS pu :I :I :z
+!FTRANS pv :I :I :z
+!FTRANS plu :I :I :z
+!FTRANS plv :I :I :z
+!! DCSE_NEMO: work around deficiency in ftrans
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in   ) ::   pu , pv    ! 1st call: before horizontal velocity 
       !                                                               ! 2nd call: ahm x these fields
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   plu, plv   ! partial harmonic operator applied to
+      REAL(wp), INTENT(in   ) ::   pu(jpi,jpj,jpk) , pv(jpi,jpj,jpk)
+!     REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   plu, plv   ! partial harmonic operator applied to
       !                                                               ! pu and pv (all the components except
       !                                                               ! second order vertical derivative term)
+      REAL(wp), INTENT(  out) ::   plu(jpi,jpj,jpk), plv(jpi,jpj,jpk) ! partial harmonic operator applied to
       INTEGER                         , INTENT(in   ) ::   kahm       ! =1 1st call ; =2 2nd call
       !
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 3211)
@@ -38,4 +38,12 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: zfuw, zdiu, zdju, zdj1u   ! 2D workspace (dyn_ldf_iso) 
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) :: zfvw, zdiv, zdjv, zdj1v   !  -      -
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "ldftra_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
 
    !! * Substitutions
@@ -134,7 +142,13 @@
       IF( ln_dynldf_hor .AND. ln_traldf_iso ) THEN
          !
+#if defined key_z_first
+         DO jj = 2, jpjm1       ! set the slopes of iso-level
+            DO ji = fs_2, fs_jpim1    
+               DO jk = 1, jpk       
+#else
          DO jk = 1, jpk         ! set the slopes of iso-level
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                   uslp (ji,jj,jk) = -1./e1u(ji,jj) * ( fsdept(ji+1,jj,jk) - fsdept(ji ,jj ,jk) ) * umask(ji,jj,jk)
                   vslp (ji,jj,jk) = -1./e2v(ji,jj) * ( fsdept(ji,jj+1,jk) - fsdept(ji ,jj ,jk) ) * vmask(ji,jj,jk)
Index: branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap.F90
===================================================================
--- branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap.F90	(revision 3187)
+++ branches/2011/DEV_r2739_STFC_dCSE/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_lap.F90	(revision 3211)
@@ -28,4 +28,11 @@
 
    PUBLIC dyn_ldf_lap  ! called by step.F90
+
+   !! * Control permutation of array indices
+#  include "oce_ftrans.h90"
+#  include "dom_oce_ftrans.h90"
+#  include "ldfdyn_oce_ftrans.h90"
+#  include "zdf_oce_ftrans.h90"
+#  include "ldfslp_ftrans.h90"
 
    !! * Substitutions
@@ -73,4 +80,9 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~ '
       ENDIF
+#if defined key_z_first
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            DO jk = 1, jpkm1
+#else
       !                                                ! ===============
       DO jk = 1, jpkm1                                 ! Horizontal slab
@@ -78,4 +90,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
+#endif
                ze2u = rotb (ji,jj,jk) * fsahmf(ji,jj,jk) * fse3f(ji,jj,jk)
                ze1v = hdivb(ji,jj,jk) * fsahmt(ji,jj,jk)
